Bug 494292 - (spacewalk-proxy-html) Review Request: spacewalk-proxy-html - The HTML component for Spacewalk Proxy
Review Request: spacewalk-proxy-html - The HTML component for Spacewalk Proxy
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Sandro Mathys
Fedora Extras Quality Assurance
:
Depends On:
Blocks: F-Spacewalk
  Show dependency treegraph
 
Reported: 2009-04-06 04:32 EDT by Miroslav Suchý
Modified: 2009-11-20 05:39 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-11-20 05:39:42 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
sandro: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Miroslav Suchý 2009-04-06 04:32:12 EDT
SRPM: http://miroslav.suchy.cz/fedora/spacewalk-proxy-html/spacewalk-proxy-html-0.4.2-1.src.rpm
SPEC: http://miroslav.suchy.cz/fedora/spacewalk-proxy-html/spacewalk-proxy-html.spec

Description:
This package contains placeholder html pages, which the Spacewalk Server
display, if you navigate to it using your browser.

rpmlint is silent.

Scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=1279144
Comment 1 Leon Keijser 2009-11-10 09:04:20 EST
This is a comment (pre-review) only, following http://fedoraproject.org/wiki/How_to_get_sponsored_into_the_packager_group#Reviewing_Packages instructions.

*  MUST: rpmlint must be run on every package. The output should be posted in the review.

- rpmlint is not completely silent:
$ rpmlint /var/lib/mock/fedora-11-x86_64/result/spacewalk-proxy-html-0.4.2-1.fc11.noarch.rpm 
spacewalk-proxy-html.noarch: W: obsolete-not-provided rhns-proxy-html
spacewalk-proxy-html.noarch: W: conffile-without-noreplace-flag /var/www/html/_rhn_proxy/index.html
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

I'm quite sure the second warning can be safely ignored though.

* MUST: The package must be named according to the Package Naming Guidelines .
- OK

* MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
- OK

* MUST: The package must meet the Packaging Guidelines .
- MINOR ISSUE: typo in %description: 'displays' instead of 'display' ;)

* MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
- OK

* MUST: The License field in the package spec file must match the actual license.
- OK

* MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]
- N/A

* MUST: The spec file must be written in American English.
- OK
    
* MUST: The spec file for the package MUST be legible.
- OK

* MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
- OK

* MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
- N/A (noarch)

* MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
- N/A (noarch)

* MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
- OK

* MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
- N/A

* MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
- N/A

* MUST: Packages must NOT bundle copies of system libraries.[11]
- OK

* MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
- N/A

* MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [13]
- OK

* MUST: A Fedora package must not list a file more than once in the spec file's %files listings.
- OK

* MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [15]
- NOTICE: spacewalk-proxy-html changes the group ownership of /var/www/html:

%attr(755,root,apache) %dir %{htmldir}

Why? The default is root.root

* MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
- OK
    
* MUST: Each package must consistently use macros.
- OK
    
* MUST: The package must contain code, or permissable content.
- OK

* MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
- N/A

* MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
- OK

* MUST: Header files must be in a -devel package.
- N/A

* MUST: Static libraries must be in a -static package.
- N/A
    
* MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
- N/A

* MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
- N/A

* MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} 
- N/A
    
* MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
- N/A
    
* MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. 
- N/A

* MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
- NOTICE: spacewalk-proxy-html creates /var/www/html while also be dependent on httpd. Isn't this line unnecessary:

install -m 755 -d $RPM_BUILD_ROOT%{htmldir}

* MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
- OK

* MUST: All filenames in rpm packages must be valid UTF-8.
- OK


SHOULD Items:
Items marked as SHOULD are things that the package (or reviewer) SHOULD do, but is not required to do.

* SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
- N/A

* SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
- N/A

* SHOULD: The reviewer should test that the package builds in mock.
- OK

* SHOULD: The package should compile and build into binary rpms on all supported architectures.
- N/A (noarch)

* SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
- OK

* SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
- N/A

* SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
- NOTICE: doesn't spacewalk-proxy-html require package 'spacewalk-proxy' or package 'spacewalk' ?

* SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
- N/A

* SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
- OK
Comment 2 Miroslav Suchý 2009-11-13 11:01:11 EST
OK, I will address this comments on Tuesday.

I only have comment to:
>- NOTICE: spacewalk-proxy-html creates /var/www/html while also be dependent on
>httpd. Isn't this line unnecessary:
>
>install -m 755 -d $RPM_BUILD_ROOT%{htmldir}
this is necessery, since httpd is not present in build time, but this one can be removed from %files:
 %dir %{htmldir}
Comment 3 Miroslav Suchý 2009-11-17 05:37:16 EST
Updated spec:
http://miroslav.suchy.cz/fedora/spacewalk-proxy-html/spacewalk-proxy-html.spec
Updated SRPM:
http://miroslav.suchy.cz/fedora/spacewalk-proxy-html/spacewalk-proxy-html-0.7.1-1.src.rpm

I fixed that typo in %description, used defattrs, removed ownership of directory, which already own httpd and add versioned Provides.

I did not add dependency to spacewalk-proxy-managements, since this is not subpackage and it will lead to circular dependency. I did not address rpmlint warning:
spacewalk-proxy-html.noarch: W: conffile-without-noreplace-flag
/var/www/html/_rhn_proxy/index.html
since I want to replace it during upgrade. The reason is that this package is updated very rarely and when is update we probably want to have visible change.
Comment 4 Sandro Mathys 2009-11-18 05:00:01 EST
OK - MUST: rpmlint must be run on every package. The output should be posted in the review.

$ rpmlint {SPECS,RPMS/noarch,SRPMS}/spacewalk-proxy-html*
spacewalk-proxy-html.noarch: W: conffile-without-noreplace-flag /var/www/html/_rhn_proxy/index.html
2 packages and 1 specfiles checked; 0 errors, 1 warnings.

Save to ignore.

OK - MUST: The package must be named according to the Package Naming Guidelines.
OK - MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. .
NEEDSWORK - MUST: The package must meet the Packaging Guidelines.

Please use %global instead of %define (and move it to the top of the spec file as people would look for it there):
http://fedoraproject.org/wiki/Packaging/Guidelines#.25global_preferred_over_.25define

Please don't obsolete a package that didn't exist in Fedora/EPEL before. This also makes the provides unnecessary.

OK - MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
OK - MUST: The License field in the package spec file must match the actual license.
OK - MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
OK - MUST: The spec file must be written in American English.
OK - MUST: The spec file for the package MUST be legible.
OK - MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task.  If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

$ md5sum spacewalk-proxy-html-0.7.1.tar.gz SOURCES/spacewalk-proxy-html-0.7.1.tar.gz
fea871e8665d756cbde595ca6932281d  spacewalk-proxy-html-0.7.1.tar.gz
fea871e8665d756cbde595ca6932281d  SOURCES/spacewalk-proxy-html-0.7.1.tar.gz

OK - MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
N/A - MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
OK - MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
N/A - MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
N/A - MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
OK - MUST: Packages must NOT bundle copies of system libraries.
N/A - MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
OK - MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
OK - MUST: A Fedora package must not list a file more than once in the spec file's %files listings.
OK - MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
OK - MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
OK - MUST: Each package must consistently use macros.
OK - MUST: The package must contain code, or permissable content.
N/A - MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
OK - MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
N/A - MUST: Header files must be in a -devel package.
N/A - MUST: Static libraries must be in a -static package.
N/A - MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
N/A - MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
N/A - MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}
N/A - MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
N/A - MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
OK - MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
OK - MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
OK - MUST: All filenames in rpm packages must be valid UTF-8.
N/A - SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
N/A - SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
OK - SHOULD: The reviewer should test that the package builds in mock.
OK - SHOULD: The package should compile and build into binary rpms on all supported architectures.
N/A - SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
N/A - SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
N/A - SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
N/A - SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg.  A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
N/A - SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.

Please fix the single NEEDSWORK and I'll be able to approve this afterwards.
Comment 5 Miroslav Suchý 2009-11-18 05:37:35 EST
> Please use %global instead of %define
Done

> Please don't obsolete a package that didn't exist in Fedora/EPEL before.
Done. Although I disagree with such step.

Updated SPEC:
http://miroslav.suchy.cz/fedora/spacewalk-proxy-html/spacewalk-proxy-html.spec
Updated SRPM:
http://miroslav.suchy.cz/fedora/spacewalk-proxy-html/spacewalk-proxy-html-0.7.2-2.src.rpm
Comment 6 Sandro Mathys 2009-11-18 09:23:25 EST
All issues have been correctly addressed.

---------------------------------------------------------------------------
   This package (spacewalk-proxy-html) is APPROVED by red (Sandro Mathys)
---------------------------------------------------------------------------
Comment 7 Miroslav Suchý 2009-11-18 09:57:39 EST
New Package CVS Request
=======================
Package Name: spacewalk-proxy-html
Short Description: The HTML component for Spacewalk Proxy
Owners: msuchy
Branches: F-11, F-12
InitialCC:
Comment 8 Jason Tibbitts 2009-11-19 13:27:47 EST
CVS done.

Note You need to log in before you can comment on or make changes to this bug.